/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Status;
import com.portofolio.entity.Status;
import com.portofolio.entity.vo.StatusId;

@Lazy
@Repository
public interface StatusDao extends CrudRepository<Status, StatusId> {
	


	

	@Query("select distinct model from Status model where model.id.kdProfile=:kdProfile ")
	List<Status> findAllList(@Param("kdProfile")Integer kdProfile,Pageable page);

	@Query("select distinct model from Status model where model.id.kdProfile=:kdProfile  and model.namaStatus like %:namaStatus% "
			+ "or (model.id.kdStatus in (select model2.kdStatusHead from Status model2 where model2.id.kdProfile=:kdProfile  and model2.namaStatus like %:namaStatus% )) "
			+ "or (model.kdStatusHead in (select model2.id.kdStatus from Status model2 where model2.id.kdProfile=:kdProfile  and model2.namaStatus like %:namaStatus% ))")
	List<Status> findAllList(@Param("kdProfile")Integer kdProfile,@Param("namaStatus")String namaStatus, Pageable page);

	@Query("select  model from Status model where model.id.kdProfile=:kdProfile  and model.id.kdStatus=:kdStatus "
			+ "or (model.id.kdStatus in (select model2.kdStatusHead from Status model2 where model2.id.kdProfile=:kdProfile  and model2.id.kdStatus=:kdStatus ))"
			+ "or (model.kdStatusHead in (select model2.id.kdStatus from Status model2 where model2.id.kdProfile=:kdProfile  and model2.id.kdStatus=:kdStatus )) ")
	List<Status> findByKdStatusWithIsHierarkiTrue(@Param("kdProfile")Integer kdProfile,@Param("kdStatus") Integer kdStatus);
	
	@Query("select model from Status model where model.id.kdProfile=:kdProfile  and model.id.kdStatus=:kdStatus ")
	List<Status> findByKdStatusWithIsHierarkiFalse(@Param("kdProfile")Integer kdProfile,@Param("kdStatus") Integer kdStatus);

	@Query("select new map(model.id.kdStatus as kdStatus "
			+ ", model.namaStatus as namaStatus,model.kdStatusHead as kdStatusHead) from Status model where model.id.kdProfile=:kdProfile  and model.kdStatusHead=:kdStatus and  model.statusEnabled = true  ")
	List<Map<String, Object>> findStatusByHead(@Param("kdProfile")Integer kdProfile,@Param("kdStatus") Integer kdStatus,Pageable page);

	@Query("select new map(model.id.kdStatus as kdStatus "
			+ ", model.namaStatus as namaStatus,model.kdStatusHead as kdStatusHead) from Status model where model.id.kdProfile=:kdProfile and model.namaStatus like %:namaStatus%  and model.kdStatusHead=:kdStatus and  model.statusEnabled = true  ")
	List<Map<String, Object>> findStatusByHead(@Param("kdProfile")Integer kdProfile,@Param("kdStatus") Integer kdStatus,@Param("namaStatus") String namaStatus,Pageable page);

	@Query("select distinct model from Status model where model.id.kdProfile=:kdProfile  and model.statusEnabled=true")
	List<Status> findAllListCombo(@Param("kdProfile")Integer kdProfile,Pageable page);

	@Query("select distinct model from Status model where model.id.kdProfile=:kdProfile  and model.namaStatus like %:namaStatus% and model.statusEnabled=true "
			+ "or (model.id.kdStatus in (select model2.kdStatusHead from Status model2 where model2.id.kdProfile=:kdProfile  and model2.namaStatus like %:namaStatus% and model2.statusEnabled=true)) "
			+ "or (model.kdStatusHead in (select model2.id.kdStatus from Status model2 where model2.id.kdProfile=:kdProfile  and model2.namaStatus like %:namaStatus% and model2.statusEnabled=true))")
	List<Status> findAllListCombo(@Param("kdProfile")Integer kdProfile,@Param("namaStatus")String namaStatus, Pageable page);

	


	
}
